#include <bits/stdc++.h>

using namespace std;

long long int mennyi(long long int szam)
{
    long long int index=0;
    while(szam>1)
    {
        szam>>=1;
        index++;
    }

    return index;
}

int main()
{
    long long int n,q;



    cin>>n>>q;

    vector<long long int> a(n);

    for(long long int i=0; i<n; i++)
    {
        cin>>a[i];
    }

    vector<long long int> b(n);

    for(long long int i=0; i<n; i++)
    {
        b[i]=mennyi(a[i]);
    }

    long long int bal, jobb;
    map<long long int,long long int> szamol;

    for(long long int i=0; i<q; i++)
    {
        cin>>bal>>jobb;

        for(long long int j=bal-1; j<=jobb-1; j++)
        {
            szamol[b[j]]++;;
        }

        long long int nagy=0;
        for(auto it:szamol)
        {
            if(it.second>nagy)
            {
                nagy=it.second;
            }
        }

        cout<<nagy<<endl;

        szamol.clear();


    }


    return 0;
}